
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
*
* Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*   Conselleria d'Infraestructures i Transport
*   Av. Blasco Ibez, 50
*   46010 VALENCIA
*   SPAIN
*
*      +34 963862235
*   gvsig@gva.es
*      www.gvsig.gva.es
*
*    or
*
*   IVER T.I. S.A
*   Salamanca 50
*   46005 Valencia
*   Spain
*
*   +34 963163400
*   dac@iver.es
*/
package es.gva.cit.catalogClient.schemas;
import es.gva.cit.catalogClient.filters.AdditionalClauses;
/**
 * This interface caontains all the fields that can
 * be used to do a search. Each "schema class" have to
 * implement it.
 * 
 * 
 * @author Jorge Piera Llodra (piera_jor@gva.es)
 */
public interface ISchemas {
/**
 * 
 * 
 * 
 * @return 
 */
    public String getTitle();
/**
 * 
 * 
 * 
 * @return 
 */
    public String getAbstract();
/**
 * 
 * 
 * 
 * @return 
 */
    public String getThemeKey();
/**
 * 
 * 
 * 
 * @return 
 */
    public String getTopic();
/**
 * 
 * 
 * 
 * @return 
 */
    public String getScale();
/**
 * 
 * 
 * 
 * @return 
 */
    public String getProvider();
/**
 * 
 * 
 * 
 * @return 
 */
    public String getDateFrom();
/**
 * 
 * 
 * 
 * @return 
 */
    public String getDateTo();
/**
 * 
 * 
 * 
 * @return 
 */
    public String getCoordinates();
/**
 * 
 * 
 * 
 * @return 
 * @param topic 
 */
    public String getTopicValue(String topic);
/**
 * 
 * 
 * 
 * @return 
 * @param value 
 */
    public String getProviderValue(String value);
/**
 * It returns the Title value. We need extra characters (like *,?,....), because
 * this profile has different behaviour to find strings
 * 
 * 
 * @return 
 * @param title The String to find
 * @param filter E (Exact), A (All words), Y (anY word)
 */
    public String getTitleValue(String title, String filter);
/**
 * This function must return a Vector of AddionalClauses to add to the query.
 * 
 * 
 * @return 
 * @param dataset 
 */
    public AdditionalClauses[] getAdditionalClauses(String[] dataset);
}


