package com.iver.cit.gvsig;

import com.hardcode.driverManager.DriverLoadException;
import com.hardcode.gdbms.engine.data.driver.DriverException;
import com.iver.andami.PluginServices;
import com.iver.andami.messages.NotificationManager;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.cit.gvsig.project.documents.table.ProjectTable;
import com.iver.cit.gvsig.project.documents.table.gui.Table;

/**
 * @author Fernando Gonzlez Corts
 */
public class RemoveTableUnion extends Extension{

	/**
	 * @see com.iver.andami.plugins.IExtension#initialize()
	 */
	public void initialize() {
		// TODO Auto-generated method stub

	}

	/**
	 * @see com.iver.andami.plugins.IExtension#execute(java.lang.String)
	 */
	public void execute(String actionCommand) {
		Table t = (Table) PluginServices.getMDIManager().getActiveWindow();
		ProjectTable pt = t.getModel();
		try {
            pt.restoreDataSource();
            // Por si acaso tenamos seleccionado un campo
            // de los de la unin, no seleccionamos
            // ningn campo.
            t.clearSelectedFields();

        } catch (DriverException e) {
            NotificationManager.addError(e.getMessage(), e);
        } catch (DriverLoadException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#isEnabled()
	 */
	public boolean isEnabled() {
		IWindow v = PluginServices.getMDIManager().getActiveWindow();

		if (v == null) {
			return false;
		}

		if (v.getClass() == Table.class) {
			Table t = (Table) v;
			if (t.getModel().getOriginal() != null){
				return true;
			}
		}
		return false;
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#isVisible()
	 */
	public boolean isVisible() {
		IWindow v = PluginServices.getMDIManager().getActiveWindow();

		if (v == null) {
			return false;
		}

		if (v instanceof Table) {
			return true;
		} else {
			return false;
		}

	}

}
