/*
 * Created on 23-mar-2006
 * 
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 */
package com.iver.cit.gvsig.gui.panels;

import org.cresques.filter.IStackManager;
import org.cresques.filter.RasterFilterStackManager;

import com.iver.cit.gvsig.fmap.layers.FLyrRaster;
import com.iver.cit.gvsig.project.documents.view.toc.gui.FLyrRasterAdjustPropertiesTocMenuEntry;

/**
 * Este interface lo implementaran las clases que quieran registrar
 * paneles en la propiedades de raster.Las clases que deben implementarlo
 * son el panel a registrar y la clase que donde van las acciones del
 * menu contextual del TOC. Cuando un usuario seleccione propiedades
 * de raster buscar todos los paneles registrados (se registran cuando se
 * carga la extensin)y ejecutar el addTabPanel para aadirlo y el 
 * actionPerformed del listener para cargar las propiedades que deben 
 * aparecer. 
 * @author Nacho Brodin (brodin_ign@gva.es)
 *
 */
public interface IRasterPropertiesRegistrable{
	
	/**
	 * Mtodo que es ejecutado desde PropertiesRasterDialog
	 * en todas los paneles que tiene aadidos.
	 * @param stackManager RasterFilterStackManager
	 * @param propsDialog PropertiesRasterDialog
	 * @param fLayer FLyrRaster 
	 */
	public void actionPerformed(RasterFilterStackManager stackManager,  PropertiesRasterDialog propsDialog, FLyrRaster fLayer);
	
	/**
	 * Asigna el gestor de pila de filtros generico al gestor de pila de pansharpening 
	 * @param stackManager RasterFilterStackManager
	 */
	public void setStackManager(RasterFilterStackManager stackManager);
	
	/**
	 * Aade el panel al cuadro de dialogo de propiedades de raster
	 * @param menu FLyrRasterAdjustPropertiesTocMenuEntry
	 */
	public void addTabPanel(FLyrRasterAdjustPropertiesTocMenuEntry menu);
	
	/**
	 * Obtiene el stackManger para este filtro
	 * @return IStackManager
	 */
	public IStackManager getStackManager();
}
