package es.prodevelop.cit.gvsig.arcims.fmap.drivers;

import com.hardcode.gdbms.engine.data.DataSource;
import com.hardcode.gdbms.engine.data.driver.DriverException;
import com.hardcode.gdbms.engine.values.Value;

public interface ArcImsAlphanumericDataSource extends DataSource {

    /**
     * Deletes the ith row of the DataSource
     *
     * @param rowId index of the row to be deleted
     *
     * @throws DriverException if the row could not be deleted
     */
    public void deleteRow(long rowId) throws DriverException;

    /**
     * Inserts a row at the end of the dataware with the specified values
     *
     * @param values Values of the inserted row fields in the field order
     * @param index index where the row will be inserted. No data is lost.
     *
     * @throws DriverException if the row could not be inserted
     */
    public void insertFilledRowAt(long index, Value[] values) throws DriverException;

    /**
     * Inserts a row at the end of the dataware
     * 
     * @param index index where the row will be inserted. No data is lost.
     *
     * @throws DriverException if the row could not be inserted
     */
    public void insertEmptyRowAt(long index) throws DriverException;

}
