package es.prodevelop.cit.gvsig.arcims.gui.panels.utils;

import javax.swing.event.ListSelectionEvent;
import javax.swing.table.DefaultTableColumnModel;

import org.apache.log4j.Logger;

import com.iver.andami.PluginServices;

import es.prodevelop.cit.gvsig.arcims.gui.panels.ServiceNamesPanel;

/**
 * This class detects changes on the available services list.
 * 
 * @author jldominguez
 */
public class ServicesTableSelectionListener extends DefaultTableColumnModel {
	
	private static Logger logger = Logger.getLogger(ServicesTableSelectionListener.class.getName());
	private ServiceNamesPanel thePanel;
	private static final long serialVersionUID = 0;

	public ServicesTableSelectionListener(ServiceNamesPanel panel) {
		super();
		thePanel = panel;
	}

	/**
	 * Updates local variables which keep the service's name and type. The
	 * service name must be in the first column of the table; the service type
	 * must be in the second column.
	 */
	public void valueChanged(ListSelectionEvent e) {
		if (e.getValueIsAdjusting())
			return;
		if (thePanel == null)
			return;
		if (thePanel.getServicesTable() == null)
			return;

		int i = thePanel.getServicesTable().getSelectedRow();
		if (i == -1)
			return; // no selection

		thePanel.setSelectedServiceType(ServicesTableModel.getColumnValueOfRow(
				thePanel.getServicesTable(), PluginServices.getText(this,
						"arcims_server_type_col_name"), i));

		thePanel.setSelectedServiceName(ServicesTableModel
				.getColumnValueOfRow(thePanel.getServicesTable(), PluginServices
						.getText(this, "name"), i));

		thePanel.getNextButton().setEnabled(true);

		logger.info("New selection in services table: type = " + thePanel.getSelectedServiceType()
				+ ", name = " + thePanel.getSelectedServiceName());
	}
}
