/*
 * Created on 02-feb-2006
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
*
* $Id: ConstantDistanceBufferVisitor.java,v 1.3.2.1 2006/11/15 00:08:17 jjdelcerro Exp $
* $Log: ConstantDistanceBufferVisitor.java,v $
* Revision 1.3.2.1  2006/11/15 00:08:17  jjdelcerro
* *** empty log message ***
*
* Revision 1.4  2006/09/15 10:42:54  caballero
* extensibilidad de documentos
*
* Revision 1.3  2006/08/29 07:21:09  cesar
* Rename com.iver.cit.gvsig.fmap.Fmap class to com.iver.cit.gvsig.fmap.MapContext
*
* Revision 1.2  2006/06/29 17:31:47  azabala
* Uses UnitUtils
*
* Revision 1.1  2006/06/20 18:20:45  azabala
* first version in cvs
*
* Revision 1.2  2006/06/02 18:20:33  azabala
* limpieza de imports
*
* Revision 1.1  2006/05/24 21:14:41  azabala
* primera version en cvs despues de refactoring orientado a crear un framework extensible de geoprocessing
*
* Revision 1.8  2006/05/01 19:18:09  azabala
* revisin general del buffer (aadidos anillos concentricos, buffers interiores y exteriores, etc)
*
* Revision 1.7  2006/03/28 16:27:16  azabala
* *** empty log message ***
*
* Revision 1.6  2006/03/07 21:01:33  azabala
* *** empty log message ***
*
* Revision 1.5  2006/03/06 19:48:39  azabala
* *** empty log message ***
*
* Revision 1.3  2006/03/05 19:57:05  azabala
* *** empty log message ***
*
* Revision 1.2  2006/02/20 19:44:21  azabala
* *** empty log message ***
*
* Revision 1.1  2006/02/17 16:31:38  azabala
* *** empty log message ***
*
* Revision 1.3  2006/02/12 21:02:58  azabala
* *** empty log message ***
*
* Revision 1.2  2006/02/09 16:01:06  azabala
* First version in CVS
*
* Revision 1.1  2006/02/02 19:46:51  azabala
* First version in CVS
*
*
*/
package com.iver.cit.gvsig.geoprocess.impl.buffer.fmap;

import org.cresques.cts.IProjection;
import org.cresques.cts.gt2.CSUTM;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.MapContext;
import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.geoprocess.core.fmap.GeoprocessException;
import com.iver.cit.gvsig.geoprocess.core.util.UnitUtils;
import com.iver.cit.gvsig.project.documents.view.gui.View;

/**
 * This FeatureVisitor computes buffers and saves
 * it to a new FLayer.
 * All IFeature of this Layer will have the same buffer
 * distance.
 * 
 * @author azabala
 *
 */
public class ConstantDistanceBufferVisitor extends BufferVisitor {
	/**
	 * buffer distance to use
	 */
	private double distance;
	
	/**
	 * Constructor
	 * @param distance buffer distance to use
	 * @throws GeoprocessException 
	 */
	public ConstantDistanceBufferVisitor(double distance) throws GeoprocessException{
		this.distance = distance;
	}
	
	public void stop(FLayer layer) {
		//we must flush JTS processors
		resultsProcessor.finish();
	}
	/**
	 * This FeatureVisitor only work with Vectorial
	 * Layers
	 */
	public boolean start(FLayer layer) {
		if(layer instanceof FLyrVect){
			return true;
		}else
			return false;
	}

	public double getBufferDistance(IGeometry g, int index) {
		//first: pass the user entry to internal units
		return UnitUtils.getInInternalUnits(distance);
	}
	
	

	public String getProcessDescription() {
		return "Computing buffers with constant distances";
	}

}


