/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 */
package com.iver.cit.gvsig.fmap.tools.Listeners;

import com.iver.cit.gvsig.fmap.tools.BehaviorException;
import com.iver.cit.gvsig.fmap.tools.Events.PointEvent;
import com.iver.cit.gvsig.fmap.tools.Listeners.ToolListener;


/**
 * Interfaz listener de arrastrado.
 *
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public interface DraggedListener extends ToolListener {
	/**
	 * Invocado cuando se hace un press sobre la vista.
	 *
	 * @param event PointEvent.
	 *
	 * @throws BehaviorException se lanza cuando falla la herramienta.
	 */
	public void press(PointEvent event) throws BehaviorException;
	
	/**
	 * Invocado cuando se hace un release sobre la vista.
	 *
	 * @param event PointEvent.
	 *
	 * @throws BehaviorException se lanza cuando falla la herramienta.
	 */
	public void release(PointEvent event) throws BehaviorException;
	
	/**
	 * Invocado cuando se hace un dragg sobre la vista.
	 *
	 * @param event PointEvent.
	 *
	 * @throws BehaviorException se lanza cuando falla la herramienta.
	 */
	public void dragg(PointEvent event) throws BehaviorException;
	
}
