package org.cresques.filter.enhancement;

import java.awt.Image;

import org.cresques.filter.RasterBuf;

/**
 * Filtro de contraste para imágenes de 16 bits.
 * @author Miguel Ángel Querol Carratalá <querol_mig@gva.es>
 *
 */
public class ContrastShortFilter extends ContrastFilter {

	public ContrastShortFilter(){
		super();
	}
	
	int diferencia = 0;
	
	public void pre(){
		exec = true;
		this.raster = (RasterBuf) params.get("raster");
		height = raster.getHeight();
        width = raster.getWidth();
        this.incrContraste = ((Integer)this.params.get("incrContraste")).intValue();

		super.pre();
	}

	public void process(int x, int y) {
		raster.getElemInt(x, y, px);
	
		for (int i = 0 ; i < 3 ; i++){			
			//************ALGORITMO DE CONTRASTE*************
			if(incrContraste >= 0){
				if (px[i] < 127){
					diferencia = 127 - px[i];
					result = px[i] - (int)((diferencia * 5) * (incrContraste*0.1)/25);
					if(result < 0)	result = 0;
					
				}
				if (px[i] > 127){
					diferencia = px[i] - 127;
					result = px[i] + (int)((diferencia * 5) * (incrContraste*0.1)/25);
					if(result > 255)	result = 255;
				}
			}
			if(incrContraste < 0){
				if(px[i] < 127){
					diferencia = 127 - px[i];
					result = px[i] + ((int)(diferencia * 1) * (int)(-incrContraste * 0.1)/25);
					if(result > 127)	result = 127;
					if(px[i] == 0 || px[i] == 0)
						if(incrContraste > -255)
							result = 0;
				}
				if(px[i] > 127){
					diferencia = px[i] - 127;
					result = px[i] - ((int)(diferencia * 1) * (int)(-incrContraste * 0.1)/25);
					if (result < 127)	result = 127;
					if(px[i] == 255 || px[i] == 254)	
						if(incrContraste > -255)
							result = 255;
				}
			}
			px[i] = result;
		}
		raster.setElemInt(x, y, px);
	}

	public void processLine(int y) {
		// TODO Auto-generated method stub
		
	}

	public int getInRasterDataType() {
		return RasterBuf.TYPE_SHORT;
	}

	public int getOutRasterDataType() {
		return RasterBuf.TYPE_SHORT;
	}

	public Object getResult(String name) {
		if (name.equals("raster")) {
            return (Object) this.raster;
        } else {
            return null;
        }
	}
	
}
